//
//  host.h
//  Infektsimulation
//
//  Created by //// on 19.08.13.
//  Copyright (c) 2013 ////. All rights reserved.
//

#include "agent.h"
#include <stdbool.h>

#ifndef Infektsimulation_host_h //include guard
#define Infektsimulation_host_h


typedef enum {HEALTHY, INFECTED, ILL, IMMUNE, DEAD} HostState;

typedef struct {
    //erstellen von agent liste? statt einzelner instanz
	Agent *agent;
	HostState state;
    
	unsigned short outbreak_time; /* start point of disease */
    unsigned short infection_time; /* time of infection */
    
	unsigned short end_of_disease; /* end point of disease */
	bool will_ill; /* host will get disease after infection */
	bool will_die; /* host will die on end of disease */
	bool will_immune; /* host will get immune on end of disease */
    
    unsigned long immunities;
    unsigned short disappear_duration; /*time until host disappears after death*/
    
    Position pos; /* host position: x/y value */
    Field* field; /* field the host is positioned on */

    List_element* list_element; /* pointer to list element so hosts can be deleted from lists easily */
    
} Host;

Host* host_create();
void host_move(Host*);
void host_process(Host* host, unsigned short inc_time);
void host_get_infection(Host *host, unsigned short time);
void host_start_disease(Host *host);
void host_end_disease(Host *host);
void host_process(Host *host, unsigned short inc_time);
void host_infect(Host *host, Agent *inc_agent, unsigned inc_time);
void host_delete(Host* host);
void host_delete_agent(Host* host);

#endif
